typedef char           SBYTE;
typedef unsigned char  BYTE;

typedef short          SWORD;
typedef unsigned short WORD;

typedef long           SDWORD;
typedef unsigned long  DWORD;

#include <dos.h>
#include <stdio.h>

extern BYTE

     attr,              /*  stores attribute, see get_vs function  */
	color_enable,      /*  0 = no color, 1 = can diaplay color  */
	ctrl_val,          /*  global byte, 1 of 2  */
	nrml_val,          /*  global byte, 2 of 2  */
	lptr,              /*  holds number of active printer  */
	cga_sw,            /*  1=comand line NO direct screen writes */

	user_enty [255],    /*  string to point the inpt routine at
					   or, is that, at which to point?  */

     org_str [81],      /*  holds original path  */

     pgm_str [81],      /*  path holding program  */

	prompts [] [40],   /*  string space for get_v_choice  */

	c_s [] [255],      /*  string space for cntrstrp
					   and decoder functions  */

	gp_str [] [255];   /*  provides 20 general-purpose global strings  */

union REGS regs;

typedef struct
	{
	BYTE ulr;
	BYTE ulc;
	BYTE lrr;
	BYTE lrc;

	BYTE attr;

	BYTE far * save;
	} window_array;

extern window_array w_a [];

/* FUNCTIONS IN HCWP_LIB  */

	void 		far range_msg 			();
	void 		far despacer 			(BYTE);

	void           far get_vs          	();

	void           far cls             	();
	void           far clw             	(BYTE);
	void           far c_clw           	(BYTE, BYTE);

	void           far beep            	();

	BYTE           far set_window      	(BYTE, BYTE, BYTE ,
								 	BYTE, BYTE, BYTE, BYTE);

	void           far window_border   	(BYTE);
	void           far scroll_window   	(BYTE, BYTE, BYTE);
	BYTE           far save_window     	(BYTE);
	void           far repl_window     	(BYTE);

	void           far _fastcall tele_out  	(BYTE);

	BYTE           far s_read_char     	();
	BYTE 		far s_read_attr 		();

	void           far _fastcall crt_out   	(BYTE);
	void 		far _fastcall c_crt_out 	(BYTE, BYTE);

	void           far prnt            	(BYTE *);
	void           far f_prnt          	(BYTE far *);

	void           far clr_prnt        	(BYTE *, BYTE);
	void           far f_clr_prnt      	(BYTE far *, BYTE);

	void           far _fastcall line_out  	(BYTE, BYTE);

	DWORD          far get_timer       	();
	void           far wait            	(BYTE);

	void           far _fastcall locate    	(BYTE, BYTE);
	void           far nrml_cursor     	();
	void           far no_cursor       	();
	void           far full_cursor     	();
	void           far find_cursor     	(BYTE *, BYTE *);

	void           far lpt_char        	(BYTE);
	void           far lpt_spaces      	(BYTE);
	void           far lpt_string      	(BYTE *);
	void           far lpt_f_string    	(BYTE far *);
	void           far lpt_tab         	(WORD);

	void           far lpt_eol         	();
	void           far lpt_blanks      	(BYTE);

	void           far lpt_line        	(BYTE, BYTE);

	void 		far get_kybd_type 		();
	void           far _fastcall get_one	(BYTE *, BYTE *);
	BYTE 		far check_shift 		();

	BYTE           far get_choice      	(BYTE);

	void 		far y_n 				();
	void 		far n_y 				();

	BYTE 		far get_v_choice		(BYTE, BYTE, BYTE *);

	void           far flush_kybd 	     ();
	BYTE 		far check_kybd 		();

	void           far see_screen 	     ();

	void           far rtrim           	(BYTE *);
	BYTE           far cntrstrp        	();

	void           far output_fail     	();
	void           far mem_fail        	();

	void           far write_eol       	(FILE *);
	void           far eol_strip       	(BYTE *);

	void           far show_help       	(BYTE * helpfile);

	void           far set_far         	(BYTE far *, BYTE *, WORD);
	void           far set_farst       	(BYTE far *, BYTE *);

	void           far get_far         	(BYTE *, BYTE far *, WORD);
	void           far get_farst       	(BYTE *, BYTE far *);

	BYTE           far dlr_format      	(BYTE, BYTE);

	void           far hard_err        	(BYTE, BYTE, BYTE far *);

	BYTE 		far parse_date 		(BYTE *, BYTE *, BYTE *,
	   		      					 BYTE *, WORD *, double *);

	void 		far ipt_box 			(BYTE, BYTE, BYTE, BYTE,
    								 	 BYTE, BYTE, BYTE *);

	// BYTE 		far inpt 				(BYTE, BYTE, BYTE, BYTE,
	//  								 BYTE, BYTE, BYTE *);

	// void           far check_heap      	();


